#include "StdAfx.h"
#include "WndHlp.h"

#include <lm.h>

extern DWORD g_dwLastError;

void 
MultipleShowWindowByDlgId(HWND hwndDlg, BOOL fShow, int nCtlIdCount, ...)
{
	register int x;
	va_list marker;

	if(!IsWindow(hwndDlg))
		return;

	va_start(marker, nCtlIdCount);
	for(x = 0; x < nCtlIdCount; x++)
	{
		ShowWindow(GetDlgItem(hwndDlg, (UINT)va_arg(marker, UINT)), fShow ? SW_SHOW : SW_HIDE);
	}
	va_end(marker);
}

BOOL 
GetFileImage(DWORD dwPermission, int *pnFileImage)
{
	BOOL fRead		= dwPermission & PERM_FILE_READ;
	BOOL fWrite		= dwPermission & PERM_FILE_WRITE;
	BOOL fCreate	= dwPermission & PERM_FILE_CREATE;

	if(!pnFileImage)
		return FALSE;

	if(fRead && fWrite && fCreate)
		*pnFileImage = 14;
	else if(fRead && fWrite)
		*pnFileImage = 11;
	else if(fRead && fCreate)
		*pnFileImage = 12;
	else if(fWrite && fCreate)
		*pnFileImage = 13;
	else if(fRead)
		*pnFileImage = 4;
	else if(fWrite)
		*pnFileImage = 3;
	else if(fCreate)
		*pnFileImage = 2;
	else 
		*pnFileImage = 10;

	return TRUE;
}

BOOL 
GetSharingType(DWORD dwType, TCHAR *lpszData)
{
	if(!lpszData)
		return FALSE;

	_tcscpy(lpszData, _T(""));
	if(dwType == STYPE_DISKTREE)
		_tcscat(lpszData, _T("Disk"));
	else if(dwType == STYPE_PRINTQ)
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T(", "));
		_tcscat(lpszData, _T("Print"));
	}
	else if(dwType == STYPE_DEVICE)
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T(", "));
		_tcscat(lpszData, _T("Device"));
	}
	else if(dwType == STYPE_IPC)
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T(", "));
		_tcscat(lpszData, _T("IPC"));
	}
	else // special (IPC$, ADMIN$, C$)
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T(", "));
		_tcscat(lpszData, _T("Administrative"));
	}

	return TRUE;
}

BOOL 
GetServerType(DWORD dwType, TCHAR *lpszData)
{
	if(!lpszData)
		return FALSE;

	_tcscpy(lpszData, _T(""));
	if(dwType & SV_TYPE_WORKSTATION)			
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("LAN Manager workstation"));
	}
	if(dwType & SV_TYPE_SERVER)				
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("LAN Manager server"));
	}
	if(dwType & SV_TYPE_SQLSERVER)			
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Server running with Microsoft SQL Server"));
	}
	if(dwType & SV_TYPE_DOMAIN_CTRL)			
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Primary domain controller")); 
	}
	if(dwType & SV_TYPE_DOMAIN_BAKCTRL)		
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Backup domain controller")); 
	}
	if(dwType & SV_TYPE_TIME_SOURCE)			
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Server running the Timesource service")); 
	}
	if(dwType & SV_TYPE_AFP)					
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Apple File Protocol server"));
	}
	if(dwType & SV_TYPE_NOVELL)				
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Novell server"));
	}
	if(dwType & SV_TYPE_DOMAIN_MEMBER)		
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("LAN Manager 2.x domain member"));
	}
	if(dwType & SV_TYPE_LOCAL_LIST_ONLY)		
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Server maintained by the browser")); 
	}
	if(dwType & SV_TYPE_XENIX_SERVER)		
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Xenix server")); 
	}
	if(dwType & SV_TYPE_NT)					
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Windows NT/Windows 2000 workstation or server")); 
	}
	if(dwType & SV_TYPE_WFW)					
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Server running Windows for Workgroups")); 
	}
	if(dwType & SV_TYPE_SERVER_NT)			
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Windows NT/Windows 2000 server that is not a domain controller")); 
	}
	if(dwType & SV_TYPE_POTENTIAL_BROWSER)	
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Server that can run the browser service")); 
	}
	if(dwType & SV_TYPE_BACKUP_BROWSER)		
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Server running a browser service as backup")); 
	}
	if(dwType & SV_TYPE_MASTER_BROWSER)		
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Server running the master browser service")); 
	}
	if(dwType & SV_TYPE_DOMAIN_MASTER)		
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Server running the domain master browser")); 
	}
	if(dwType & SV_TYPE_DOMAIN_ENUM)			
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Primary domain")); 
	}
	if(dwType & SV_TYPE_WINDOWS)				
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Windows 95 or later")); 
	}
	if(dwType & SV_TYPE_ALL)					
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Server"));
	}
	if(dwType & SV_TYPE_CLUSTER_NT)
	{
		if(_tcslen(lpszData) > 0)
			_tcscat(lpszData, _T("\r\n"));

		_tcscat(lpszData, _T("Server clusters available in the domain")); 
	}

	return TRUE;
}

BOOL 
ReportLastError(LPSTR pszErrMsg, LPCTSTR lpcszCaption, BOOL bShow, DWORD dwLastError)
{
	LPVOID lpMsgBuf = 0;
	int cchSizeOf = 1024;

	if(dwLastError == 0)
		dwLastError = g_dwLastError = GetLastError();
	else
		g_dwLastError = dwLastError;

	if(dwLastError != NOERROR)
	{
		FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_FROM_SYSTEM, 
			0, dwLastError, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&lpMsgBuf, cchSizeOf, 0);

		if(lpMsgBuf)
		{
			pszErrMsg = (LPTSTR)lpMsgBuf;

			if(bShow)
				//DialogBoxParam(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDD_ERROR), AfxGetMainWnd(), ErrorDlgProc, (LPARAM)(LPCTSTR)lpcszCaption)
				::MessageBox(AfxGetMainWnd()->m_hWnd, pszErrMsg, lpcszCaption, MB_OK | MB_ICONINFORMATION);

			if(pszErrMsg)
			{
				*pszErrMsg = '\0';

				//	eliminate \r\n from buffer
				{
					int i, j = 0, nLen = _tcslen((LPCTSTR)lpMsgBuf) + sizeof(TCHAR);
					TCHAR sz[1024];

					for(i = 0; i < nLen; i++)
					{
						TCHAR tch = ((LPCTSTR)lpMsgBuf)[i];
						if(tch != _T('\r') && tch != _T('\n'))
							sz[j] = tch;
						else
							sz[j] = _T(' ');
						j++;
					}
					sz[j] = _T('\0');
					if(sz[j - 1] == _T('\r') || sz[j - 1] == _T('\r'))
						sz[j - 1] = _T('\0');
					if(sz[j - 2] == _T('\n') || sz[j - 2] == _T('\n'))
						sz[j - 2] = _T('\0');
					j = _tcslen(sz);
					for(i = j - 1; i >= 0; i--)
					{
						if(sz[i] == _T(' '))
							sz[i] = _T('\0');
						else
							break;
					}

					_tcscpy(pszErrMsg, sz);
				}
			}

			LocalFree(lpMsgBuf);
			lpMsgBuf = 0;
		}
		else
		{
			if(pszErrMsg)
				_tcscpy(pszErrMsg, _T("Cannot allocate error message buffer."));
		}
	}
	else if(pszErrMsg)
		_tcscpy(pszErrMsg, _T("No error."));

	return pszErrMsg ? TRUE : FALSE;
}
